
int parsebuffer_crea(void *b)
{
  int n;
  int mloc;

#if 0
  mloc = buffer_getloc(b);
  buffer_skip_bytes(b,4);
  n = buffer_read_int(b);
  buffer_setloc(b,mloc);
  buffer_skip_bytes(b,20);
  buffer_skip_bytes(b,n);
#else

  int loc;
  int i,nn;
  char *s,*s2;
  void *btmp;
  unsigned char *buffer;
  unsigned char *obuffer = NULL;
  float f;
  unsigned int flags1,flags2,flags;
  int m,nuncomp,nin,nout,err;
  int ndata;

  mloc = buffer_getloc(b);
  buffer_skip_bytes(b,4);
  ndata = buffer_read_int(b);
  flags1 = buffer_read_uint(b);
  printf("flags 1 = ");
  printflags(flags1);
  m = buffer_read_int(b);
  printf("formid = %i\n",m);
  flags2 = buffer_read_uint(b);
  printf("flags 2 = ");
  printflags(flags2);

  buffer_setloc(b,mloc);
  buffer_skip_bytes(b,20);

  if (flags1 & 0x00040000) {
    printf("Data is compressed\n");
    nuncomp = buffer_read_int(b);
    buffer = buffer_getbuf(b);
    nin = ndata-4;
    nout = 10*nin;
    obuffer = (unsigned char *)malloc(nout*sizeof(unsigned char));
    err = uncompress(obuffer,(uLongf *)(&nout),&(buffer[buffer_getloc(b)]),nin);
    if (err == Z_OK) {
      // printf("err = OK\n");
    } else if (err == Z_MEM_ERROR) {
      printf("err = MEM\n");
    } else if (err == Z_BUF_ERROR) {
      printf("err = BUF\n");
    } else if (err == Z_DATA_ERROR) {
      printf("err = DATA\n");
    } else {
      printf("Unknown error\n");
    }
    if (nout != nuncomp) {
      printf("Uncompressed data is of wrong size\n");
      exit(-1);
    }
    btmp = b;
    b = buffer_new(obuffer,(int)nout);
  } else {
    buffer = buffer_getbuf(b);
    btmp = b;
    b = buffer_new(&(buffer[buffer_getloc(btmp)]),ndata);
  }

  while (buffer_eof(b) != 1) {
    loc = buffer_getloc(b);
    s = buffer_read_string4(b);
    printf("Chunk name: %s\n",s);
    if (strcmp(s,"EDID") == 0) {
      n = buffer_read_short(b);
      printf("CREA/EDID %i\n",n);
      s2 = buffer_read_nstring(b,n);
      printf("%s\n",s2);
      free(s2);
    } else if (strcmp(s,"FULL") == 0) {
      n = buffer_read_short(b);
      printf("CREA/FULL %i\n",n);
      s2 = buffer_read_nstring(b,n);
      printf("%s\n",s2);
      free(s2);
    } else if (strcmp(s,"MODL") == 0) {
      n = buffer_read_short(b);
      printf("CREA/MODL %i\n",n);
      s2 = buffer_read_nstring(b,n);
      printf("%s\n",s2);
      free(s2);
    } else if (strcmp(s,"MODB") == 0) {
      n = buffer_read_short(b);
      printf("CREA/MODB %i\n",n);
      f = buffer_read_float(b);
      printf("%f\n",f);
    } else if (strcmp(s,"MODT") == 0) {
      n = buffer_read_short(b);
      printf("CREA/MODT %i\n",n);
      buffer_skip_bytes(b,n);
    } else if (strcmp(s,"NIFZ") == 0) {
      n = buffer_read_short(b);
      printf("CREA/NIFZ %i\n",n);
      s2 = buffer_read_nstring(b,n);
      for (i = 0; i < n-1; i++) { // Excluding the last 0.
	if (s2[i] == '\0') s2[i] = '\n';
      }
      printf("%s\n",s2);
      free(s2);
    } else if (strcmp(s,"NIFT") == 0) {
      n = buffer_read_short(b);
      printf("CREA/NIFT %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"ACBS") == 0) {
      n = buffer_read_short(b);
      printf("CREA/ACBS %i\n",n);
      flags = buffer_read_uint(b);
      printflags(flags);
      n = buffer_read_ushort(b);
      printf("%i\n",n);
      n = buffer_read_ushort(b);
      printf("%i\n",n);
      n = buffer_read_ushort(b);
      printf("%i\n",n);
      n = buffer_read_short(b);
      printf("%i\n",n);
      n = buffer_read_ushort(b);
      printf("%i\n",n);
      n = buffer_read_ushort(b);
      printf("%i\n",n);
    } else if (strcmp(s,"SNAM") == 0) {
      n = buffer_read_short(b);
      printf("CREA/SNAM %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
      n = buffer_read_ubyte(b); // NPC has byte as rank
      printf("%i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
    } else if (strcmp(s,"INAM") == 0) {
      n = buffer_read_short(b);
      printf("CREA/INAM %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"RNAM") == 0) {
      n = buffer_read_short(b);
      printf("CREA/RNAM %i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
    } else if (strcmp(s,"SPLO") == 0) {
      n = buffer_read_short(b);
      printf("CREA/SPLO %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"SCRI") == 0) {
      n = buffer_read_short(b);
      printf("CREA/SCRI %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"CNTO") == 0) {
      n = buffer_read_short(b);
      printf("CREA/CNTO %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"AIDT") == 0) {
      n = buffer_read_short(b);
      printf("CREA/AIDT %i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      flags = buffer_read_uint(b);
      printflags(flags);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
      n = buffer_read_ushort(b);
      printf("%i\n",n);
    } else if (strcmp(s,"PKID") == 0) {
      n = buffer_read_short(b);
      printf("CREA/PKID %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"DATA") == 0) {
      n = buffer_read_short(b);
      printf("CREA/DATA %i\n",n);
      for (i = 0; i < 4; i++) {
	n = buffer_read_ubyte(b);
	printf("%i\n",n);
      }
      for (i = 0; i < 2; i++) {
	n = buffer_read_ushort(b);
	printf("%i\n",n);
      }
      for (i = 0; i < 2; i++) {
	n = buffer_read_ubyte(b);
	printf("%i\n",n);
      }
      n = buffer_read_ushort(b);
      printf("%i\n",n);
      for (i = 0; i < 8; i++) {
	n = buffer_read_ubyte(b);
	printf("%i\n",n);
      }
    } else if (strcmp(s,"ZNAM") == 0) {
      n = buffer_read_short(b);
      printf("CREA/ZNAM %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"CSCR") == 0) {
      n = buffer_read_short(b);
      printf("CREA/CSCR %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"CSDT") == 0) {
      n = buffer_read_short(b);
      printf("CREA/CSDT %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"CSDI") == 0) {
      n = buffer_read_short(b);
      printf("CREA/CSDI %i\n",n);
      n = buffer_read_int(b);
      printf("%i\n",n);
    } else if (strcmp(s,"CSDC") == 0) {
      n = buffer_read_short(b);
      printf("CREA/CSDC %i\n",n);
      n = buffer_read_ubyte(b);
      printf("%i\n",n);
    } else if (strcmp(s,"BNAM") == 0) {
      n = buffer_read_short(b);
      printf("CREA/BNAM %i\n",n);
      f = buffer_read_float(b);
      printf("%f\n",f);
    } else if (strcmp(s,"TNAM") == 0) {
      n = buffer_read_short(b);
      printf("CREA/TNAM %i\n",n);
      f = buffer_read_float(b);
      printf("%f\n",f);
    } else if (strcmp(s,"WNAM") == 0) {
      n = buffer_read_short(b);
      printf("CREA/WNAM %i\n",n);
      f = buffer_read_float(b);
      printf("%f\n",f);
    } else if (strcmp(s,"NAM0") == 0) {
      n = buffer_read_short(b);
      printf("CREA/NAM0 %i\n",n);
      s2 = buffer_read_nstring(b,n);
      printf("%s\n",s2);
      free(s2);
    } else if (strcmp(s,"NAM1") == 0) {
      n = buffer_read_short(b);
      printf("CREA/NAM1 %i\n",n);
      s2 = buffer_read_nstring(b,n);
      printf("%s\n",s2);
      free(s2);
    } else if (strcmp(s,"KFFZ") == 0) {
      n = buffer_read_short(b);
      printf("CREA/KFFZ %i\n",n);
      s2 = buffer_read_nstring(b,n);
      for (i = 0; i < n-1; i++) { // Excluding the last 0.
	if (s2[i] == '\0') s2[i] = '\n';
      }
      printf("%s\n",s2);
      free(s2);
    } else {
      printf("Unknown chunk name\n");
      exit(-1);
    }
    free(s);
  }

  printf("End of CREA\n");

  buffer_free(b);
  b = btmp;
  buffer_setloc(b,mloc);
  buffer_skip_bytes(b,20);
  buffer_skip_bytes(b,ndata);
  if (flags1 & 0x00040000) {
    free(obuffer);
  }

#endif

  return -1;
}
